<template>
  <v-row justify="center">
    <v-dialog
      v-model="usersUpdate.open"
      @keydown.esc="handleClose"
      @click:outside="handleClose"
      width="850px"
    >
      <v-card>
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-account-edit</v-icon
              ><b>Editar dados do usuário</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text>
          <v-form ref="form" v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    autofocus
                    v-model="user.name"
                    label="Nome*"
                    required
                    prepend-icon="mdi-pencil-outline"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="user.surname"
                    label="Sobrenome*"
                    required
                    prepend-icon="mdi-pencil-box-outline"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="user.birthday"
                    v-mask="mask"
                    label="Data de nascimento"
                    required
                    prepend-icon="mdi-calendar-range"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="user.matriculation"
                    label="Matrícula*"
                    required
                    prepend-icon="mdi-file-document-edit"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-select
                    v-model="user.document.documentType"
                    prepend-icon="mdi-badge-account-horizontal-outline"
                    :items="documentTypes"
                    item-value="type"
                    item-text="label"
                    label="Tipo de documento*"
                    required
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="user.document.documentNumber"
                    label="Número do documento*"
                    required
                    prepend-icon="mdi-file-document-edit-outline"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="6">
                  <v-text-field
                    v-model="user.email"
                    label="Email"
                    prepend-icon="mdi-mail"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="6">
                  <v-text-field
                    v-model="user.password"
                    label="Nova Senha"
                    prepend-icon="mdi-lock"
                    required
                    :type="showPassword ? 'text' : 'password'"
                    :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
                    @click:append="showPassword = !showPassword"
                    @input="checkMinimumCharacter"
                    :messages="!checkMinimumCharacter ?[] : ['A senha deve ter pelo menos 6 caracteres'] "
                  ></v-text-field>
                </v-col>
              </v-row>
              <small>* campo obrigatório</small>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer></v-spacer>
          <v-btn text @click="handleClose">Cancelar</v-btn>
          <v-btn color="primary" elevation="0" :disabled="!valid || !checkMinimumCharacter" @click="handleUpdate">Salvar</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'
import { mask } from 'vue-the-mask'
import user from '../../services/user'

export default {
  name: 'UsersUpdate',
  components: {},
  directives: {
    mask,
  },
  data: () => ({
    showPassword: false,
    minimumCharacter: false,
    user: {
      id: '',
      name: '',
      surname: '',
      birthday: null,
      password: '',
      matriculation: '',
      email: '',
      document: {
        documentType: '',
        documentNumber: '',
      },
      entities: [],
    },
    date: null,
    documentTypes: [
      { type: 'RG', label: 'Registro Geral' },
      { type: 'CPF', label: 'Cpf' },
      { type: 'passport', label: 'Passaporte' },
    ],
    mask: '##/##/####',
    valid: false,
    show1: false,
    editing: false,
    addingEntity: false,
    editedEntity: {
      entity: '',
      privileges: '',
    },
    userRoles: [],
    allPrivileges: [],
    allEntities: [],
  }),
  computed: {
    ...mapState('user', ['usersUpdate']),
  },
  watch: {
    usersUpdate(usersUpdate) {
      this.user = JSON.parse(JSON.stringify(usersUpdate.user))
    },
    'user.password' : {
      handler(newPassword) {
      console.log(newPassword)
      this.checkMinimumCharacter();
      },
      deep:true
    },
  },
  methods: {
    checkMinimumCharacter() {
    this.valid = this.user.password.length >= 6 || this.user.password.length === 0;
    },
    ...mapMutations('user', ['UPDATE_USERS_UPDATE']),
    async handleClose() {
      await this.UPDATE_USERS_UPDATE({
        open: false,
        user: {
          id: '',
          name: '',
          surname: '',
          birthday: '',
          matriculation: '',
          email: '',
          document: {
            documentType: '',
            documentNumber: '',
          },
        },
      })
    },
    async handleUpdate() {
      console.log('update')
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userUpdate').id
      const userId = this.user.id
      let update = {}

      for (let attr in this.user) {
        if (this.user.hasOwnProperty(attr) && this.user[attr] !== this.usersUpdate.user[attr]) {
          if (attr === 'document') {
            for (let attrs in this.user[attr]) {
              if (
                this.user[attr].hasOwnProperty(attrs) &&
                this.user[attr][attrs] !== this.usersUpdate.user[attr][attrs]
              ) {
                if (!update[attr]) update[attr] = {}
                update[attr][attrs] = this.user[attr][attrs]
              }
            }
          } else update[attr] = this.user[attr]
        }
      }
      if (update.birthday) {
        let day = Number(update.birthday.slice(0, 2))
        let month = Number(update.birthday.slice(3, 5) - 1)
        let year = Number(update.birthday.slice(6, 10))
        let data = new Date(year, month, day)
        let timestamp = data.getTime()
        update.birthday = timestamp
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.updateUser(entityId, actionId, update, userId)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Dados usuário <b>modificados</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('updateUser')
          this.handleClose()
        }
      } catch (e) {
        console.log('catch role update', e)
      } finally {
        this.$emit('updateUser')
        this.handleClose()
      }
    },
    addEntity() {
      this.editing = true
      this.addingEntity = true
    },
    cancelEditing() {
      this.editing = false
      this.addingEntity = false
    },
    addToEntities() {
      this.editing = false
      this.addingEntity = false
      const selectedEntity = this.allEntities.filter((value) => {
        return value.id === this.editedEntity.entity
      })[0]
      const selectedPrivilege = this.allPrivileges.filter((value) => {
        return value.id === this.editedEntity.privileges
      })[0]
      const userRole = {
        entity: selectedEntity,
        privilege: selectedPrivilege,
      }
      console.log('useRole', userRole)
      this.userRoles.push(userRole)
      this.user.entities.push(this.editedEntity)
    },
    editEntity(entity, index) {
      this.user.entities.splice(index, 1)
      this.userRoles.splice(index, 1)
      this.editing = true
      this.addingEntity = true
    },
    removeEntity(index) {
      this.user.entities.splice(index, 1)
      this.userRoles.splice(index, 1)
    },
  },
}
</script>

<style scoped></style>
